JSEPackage("ViaMichelin.Api.Model.Itinerary.Header");

/**
 * @class ViaMichelin.Api.Model.Itinerary.Header
 * @constructor
 * @param {Object} value
 */
ViaMichelin.Api.Model.Itinerary.Header = function(value) {
	for(var item in value){
		this[item] = value[item];
	}
};
ViaMichelin.Api.Model.Itinerary.Header.prototype = {
	vehicle : null,
	itiType : null,
	idx 	: null,
	itidate : null,
	startMapURL : null,
	destMapURL  : null,
	summaries : [ ],
	/**
	 * Retourne le cout de l'itinéraire
	 * @param {int} indice
	 * @param {int} itineraryCaravan
	 * @param {String} vehicleType
	 * @return {Float}
	 */
	getTollCost : function(indice, itineraryCaravan, vehicleType) {
		var result = 0;
		var vehicle;
		if (itineraryCaravan == 1) {
			vehicle = "CARAVAN";
		} else {
			vehicle = vehicleType;
		}
		result = Math.round(this.summaries[indice].tollCost[vehicle.toLowerCase()])/100;
		return result;
	},
	/**
	 * Retourne le montant des taxes
	 * @param {int} indice
	 * @param {int} itineraryCaravan
	 * @param {String} vehicleType
	 * @return {Float}
	 */
	getRoadTaxCost : function(indice, itineraryCaravan, vehicleType) {
		var vehicle;
		if (itineraryCaravan == 1) {
			vehicle = "CARAVAN";
		} else {
			vehicle = vehicleType;
		}
		return Math.round(this.summaries[indice].CCZCost[vehicle.toLowerCase()])/100;
	},
	toString : function(){
		var txt = "[ViaMichelin.Api.Itinerary.Header] ";
		var current = this;
		for(var ele in current){
			if(typeof(current[ele]) != "function"){
				txt+= "{"+ ele +" : "+ current[ele] +"} ,";
			}
		}
		return txt;
	}
};
