JSEPackage("ViaMichelin.Api.Util.LandList");

JSEImportApi("JSE.HTML");
JSEImportApi("ViaMichelin.Api.Util.Country");
JSEImportTrad("ViaMichelin.Api.Trad.Util.LandList");

ViaMichelin.Api.Util.LandList = {
	/****************************************************************************/
	/*  Fonctions propres à l'initialisation de la comboBox de choix de langue  */
	/****************************************************************************/
	getLandList : function(o, value) {
		this.initLandList(o,ViaMichelin.Api.Trad.Util.LandList.MapLandList, value);
	},
	getItineraryLandList : function(o, value) {
		this.initLandList(o,ViaMichelin.Api.Trad.Util.LandList.ItineraryLandList, value);
	},
	getISOLandList : function(o, value) {
		this.initISOLandList(o,ViaMichelin.Api.Trad.Util.LandList.MapLandList, value);
	},
	getISOItineraryLandList : function(o, value) {
		this.initISOLandList(o,ViaMichelin.Api.Trad.Util.LandList.ItineraryLandList, value);
	},
	initLandList : function(o, base, value) {
		if (value == null || value == "undefined" || value == "") {
			value = "1424";
		}
		if ($_id(o)) {
			o = $_id(o);
			//o.innerHTML = base;
			for (var i=1; i < base.length; i++)
			{
				var opt = new Option(base[i][1],base[i][0]);
				o.options[o.options.length] = opt;
			}
			if (value != null)
			{
				var i = 0;
				while (i < o.options.length)
				{
					if (o.options[i].value == value) {
						o.selectedIndex = i;
						i = o.options.length;
					}
					i++;
				}
			}
		}
	},
	initISOLandList : function(o, base, value) {
		if (value == null || value == "undefined" || value == "") {
			value = "FRA";
		}
		if ($_id(o)) {
			o = $_id(o);
			//o.innerHTML = base;
			for (var i=1; i < base.length; i++)
			{
				var opt = new Option(base[i][1],ViaMichelin.Api.Util.Country.getISOCodeFromCountryCode(base[i][0]));
				o.options[o.options.length] = opt;
			}
			if (value != null)
			{
				var i = 0;
				while (i < o.options.length)
				{
					if (o.options[i].value == value) {
						o.selectedIndex = i;
						i = o.options.length;
					}
					i++;
				}
			}
		}
	},
	isUK : function(){
		var bodyClass = JSE.HTML.getClassName(document.body);
		if (bodyClass)
			return bodyClass.indexOf("en-GB") > -1;
		else return false;
	},
	isFrance : function(){
		var bodyClass = JSE.HTML.getClassName(document.body);
		if (bodyClass)
		return bodyClass.indexOf("fr-FR") > -1;
		else return false;
	}
};

ViaMichelin.Api.Util.extend(ViaMichelin.Api.Util.LandList);