JSEPackage("ViaMichelin.Api.Util.Poi");

ViaMichelin.Api.Util.Poi = {
	SIMPLE_POI_HOTEL      : "POI HOTEL",
	SIMPLE_POI_RESTAURANT : "POI RESTAURANT",
	SIMPLE_POI_TOURISM    : "POI TOURISM",
	SIMPLE_POI_DEFAULT    : "POI DEFAULT",
	
	/*****************************************************************************/
	/*   Nouvelles fonctions pour l'affichage des pastilles                      */
	/*****************************************************************************/
	/**
	 * @param {String} n				numéro qui doit apparaitre sur la puce
	 * @param {String} color			couleur de la puce
	 * @param {String} type mini/maxi	taille de la puce
	 * @param {Object} option
	 * @return {String}
	 */
	drawPoiMap: function (n, color, type, option) {
		var strType = "";
		var strHover = "onMouseOver=\"this.parentNode.style.zIndex=1000;\" onmouseout=\"this.parentNode.style.zIndex=2\"";
		
		if(typeof(type) != "undefined") {
			strType = "ui-picto-poi"+ ViaMichelin.Api.Util.capitalize(type);
		}
		if(typeof(option) != "undefined") {
			if(typeof(option.over) != "undefined" && option.over == false){
				strHover = "";
			}
		}
		return '<div class="ui-picto-poi '+ strType +'" '+ strHover +'>'
			+ (navigator.isIE6 
					? '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath +'all/s.gif" style="filter:progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\''+ ViaMichelin.Api.Constants.System.ApiImgPath +'/all/pastille/'+color+'_big_shaded_blazon.png\', sizingMethod=\'scale\');" />'
					: '<img src="'+ ViaMichelin.Api.Constants.System.ApiImgPath +'all/pastille/' + color + '_big_shaded_blazon.png" />')
			+ '<div>' + n + '</div>'
			+ '</div>';
	},
	drawPoiMapGreen: function (n, type, option) {
		return this.drawPoiMap(n, "green", type, option);
	},
	drawPoiMapRed: function (n, type, option) {
		return this.drawPoiMap(n, "red", type, option);
	},
	drawPoiMapBlack: function (n, type, option) {
		return this.drawPoiMap(n, "black", type, option);
	},
	drawPoiMapClassified: function (n, type, option) {
		return this.drawPoiMap(n, "orange", type, option);
	},
	drawPoiMapYellow: function (n, type, option) {
		return this.drawPoiMap(n, "yellow", type, option);
	},
	drawPoiMapBlue: function (n, type, option) {
		return this.drawPoiMap(n, "blue", type, option);
	},
	drawPoiMapWhite: function (n, type, option) {
		return this.drawPoiMap(n, "white", type, option);
	},
	/**
 	 * 
 	 */
 	drawPoiMapGreenPhoto : function(poi, n, type){
 		var isPhotoExist = false;
 		if (poi.photoURLs && poi.photoURLs[0] && poi.photoURLs[0] != ""){
 			isPhotoExist = true
 		}
 		
 		var nbStars = 0;
 		if (poi.metaNums && poi.metaNums[0]){
 			nbStars = poi.metaNums[0];
 		}
 		
 		if (isPhotoExist){
			return '<div style="top:0px;left:0px;border:1px outset black;background-color:#FFFFFF;padding:1px;margin:0" onMouseOver="this.parentNode.style.zIndex=1000;" onmouseout="this.parentNode.style.zIndex=2">'
				+ '<img style="width:26px;height:27px;margin:0px;padding:0px;border:none;display:block;" src="' + poi.photoURLs[0] + '" onload="ViaMichelin.Api.Util.resizeImageByStars(this,26,27,'+nbStars+');" onMouseOver="ViaMichelin.Api.Util.onMouseOverResizeAnimate(this, this.parentNode);" onmouseout="ViaMichelin.Api.Util.onMouseOutResizeAnimate(this, this.parentNode)"/>'
				+ '</div>';
 		}
 		else{
 			return ViaMichelin.Api.Util.drawPoiMap(n, "green", type);
 		}
 	},
	/*****************************************************************************/
	/*    Fonctions propres à l'affichage de pastilles colorées et numérotées    */
	/*****************************************************************************/
	drawMiniPastilleVerte : function(n) {return '<div class="GreenSmallDisc"/>'+n+'</div>';},
	drawMiniPastilleNoire : function(n) {return '<div class="BlackSmallDisc"/>'+n+'</div>';},
	drawMiniPastilleJaune : function(n) {return '<div class="YellowSmallDisc"/>'+n+'</div>';},
	drawMiniPastilleRouge : function(n) {return '<div class="RedSmallDisc"/>'+n+'</div>';},
	drawMiniPastilleBleue : function(n) {return '<div class="BlueSmallDisc"/>'+n+'</div>';},
	drawMiniPastilleGrise : function(n) {return '<div class="GreySmallDisc"/>'+n+'</div>';},

	drawMiniPastilleBNP : function(n) {return '<div class="miniPastilleBNP"/></div>';},

	drawCartePastilleBrandPlacementPrint : function(poi) {return '<div class="cartePastillePOD"><img src="/client_data/' + poi.clientPath + '/' + ViaMichelin.Api.Constants.System.ApiLang + '/map_icon/mapiconpoi' + poi.iconsId + '.gif" class="cartePastillePODImg"/></div>';},
	
 	/**
 	 * 
 	 */
 	onMouseOverResizeAnimate : function(elementHTML, oDiv){
 		return;
 		if (!elementHTML.getAttribute("origHeight") || elementHTML.getAttribute("origHeight") == parseInt(elementHTML.style.height))
		{ 		
	 		var animParameters = new Object();
			animParameters.htmlElement = elementHTML;
			animParameters.rules = [{
				cssProperty : "height",
				from 		: parseInt(elementHTML.style.height),
				to 			: animParameters.from*5
			}];
			elementHTML.setAttribute("origHeight", parseInt(elementHTML.style.height));
			animParameters.transition = "speedDown";
			animParameters.duration = 250;
			animParameters.fps = 50;
			var deltaY =  - parseInt((parseInt(elementHTML.style.height)*5 - parseInt(elementHTML.style.height)) /2);
			JSELaunch("ViaMichelin.Api.UI.AnimateUIComponent", animParameters, null, ViaMichelin.Api.Constants.System.ApiJSEPath);
			
			var animParameters = new Object();
			animParameters.htmlElement = elementHTML;
			animParameters.rules = [{
				cssProperty : "width",
				from 		: parseInt(elementHTML.style.width),
				to			: animParameters.from*5
			}];
			elementHTML.setAttribute("origWidth", parseInt(elementHTML.style.width));
			animParameters.transition = "speedDown";
			animParameters.duration = 250;
			animParameters.fps = 50;
			var deltaX =  - parseInt((parseInt(elementHTML.style.width)*5 - parseInt(elementHTML.style.width)) /2);
			JSELaunch("ViaMichelin.Api.UI.AnimateUIComponent", animParameters, null, ViaMichelin.Api.Constants.System.ApiJSEPath);
			
			var animParameters = new Object();
			animParameters.htmlElement = oDiv;
			animParameters.rules = [{
				cssProperty : "top",
				from		: parseInt(oDiv.style.top),
				to			: parseInt(oDiv.style.top) + deltaY
			}];
			oDiv.setAttribute("origHeight", parseInt(oDiv.style.top));
			animParameters.transition = "speedDown";
			animParameters.duration = 250;
			animParameters.fps = 50;
			JSELaunch("ViaMichelin.Api.UI.AnimateUIComponent", animParameters, null, ViaMichelin.Api.Constants.System.ApiJSEPath);
			
			var animParameters = new Object();
			animParameters.htmlElement = oDiv;
			animParameters.rules = [{
				cssProperty : "left",
				from		: parseInt(oDiv.style.left),
				to			: parseInt(oDiv.style.left) + deltaX
			}];
			oDiv.setAttribute("origWidth", parseInt(oDiv.style.left));
			animParameters.transition = "speedDown";
			animParameters.duration = 250;
			animParameters.fps = 50;
			JSELaunch("ViaMichelin.Api.UI.AnimateUIComponent", animParameters, null, ViaMichelin.Api.Constants.System.ApiJSEPath);
		}
 	},
 	
 	onMouseOutResizeAnimate : function(elementHTML, oDiv){
 		return;
 		elementHTML.style.height = elementHTML.getAttribute("origHeight") + "px";
		elementHTML.style.width = elementHTML.getAttribute("origWidth")  + "px";
		oDiv.style.top = oDiv.getAttribute("origHeight") + "px";
		oDiv.style.left = oDiv.getAttribute("origWidth")  + "px";
 	},
 	
 	/**
	 * Retaille l'image avec des valeurs winWidth et winHeight max tout en gardant le ratio et en prenant en charge les étoiles
	 * @param {HTMLElement} image
	 * @param {int} winWidth
	 * @param {int} winHeight
	 * @param {int} nbStars : nombre d'étoiles du poi
	 * @return {void}
	 */
 	resizeImageByStars : function(image,winWidth,winHeight,nbStars){
 		var tabEtoileTaille = [1, 1.5, 2, 3, 5];
 		if (parseInt(nbStars) > 4) nbStars = 1;
 		var ratioEtoile = tabEtoileTaille[nbStars];
 		var im = new Image();
		im.src = image.src;
		
		if (im.width>0 && im.height>0) {
			image.style.width = im.width+"px";
			image.style.height = im.height+"px";
			image.style.position = "relative";
			var width = im.width;
			var height = im.height;
			var ratio = width/height;
			if (winWidth-width <= winHeight-height) {
				if (width > winWidth) {
					image.style.width = parseInt(winWidth*ratioEtoile)+"px";
					image.style.height = parseInt(winWidth*ratioEtoile/ratio)+"px";
				}
			} else if (height > winHeight) {
				image.style.height = parseInt(winHeight*ratioEtoile)+"px";
				image.style.width = parseInt(ratio*winHeight*ratioEtoile)+"px";
			}
		}
		
		//Cette fonction est utilisée également par la roadSheet, il ne faut pas que la div soit en position absolue
		//Ne marche pas dans les cartes sous IE7 : les images apparaissent en blanc
		//=> Solution = ajout de !navigator.isIE
		if (image.parentNode && image.parentNode.parentNode && image.parentNode.parentNode.className.indexOf("ui-picto-poi")< 0 && !navigator.isIE){
			image.parentNode.style.position = "relative";
		}
 	},
 	
	/**
	 * Retourne le code HTML pour afficher la quotation d'un Poi (H,R,T)
	 * @param {Poi} poi
	 * @return {String}
	 */
	drawRatingPoi :function(poi){
		var content = "";
		var type = ViaMichelin.Api.Util.getSimpleTypePoi(poi);
		
		if(poi != null){
			switch(type){
				case ViaMichelin.Api.Util.SIMPLE_POI_HOTEL :
					if(	poi.icons && poi.icons.length > 0 && poi.icons[2]!="" && typeof(poi.icons[2])!="undefined" ){
						var img_src = poi.icons[2];
						var img_alt = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
						var img_title = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
						
						content = '<img src="'+img_src+'" alt="'+img_alt+'" title="'+img_title+'"/>';
					}
					break;
				case ViaMichelin.Api.Util.SIMPLE_POI_RESTAURANT :
				
					if( poi.icons && poi.icons.length > 0 && (poi.icons[2]!="" || poi.icons[4]!="")){
						if(poi.icons[2]!="" && typeof(poi.icons[2])!="undefined"){
							var img_src   = poi.icons[2];
							var img_alt   = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
							var img_title = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
							
							content+= '<img src="'+img_src+'" alt="'+img_alt+'" title="'+img_title+'"/>';
						}
						
						if(poi.icons[4]!="" && typeof(poi.icons[4])!="undefined"){
							var img_src   = poi.icons[4];
							var img_alt   = poi.icons[5].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
							var img_title = poi.icons[5].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
							
							content+= '<img src="'+img_src+'" alt="'+img_alt+'" title="'+img_title+'"/>';
						}
					}
					break;
				case ViaMichelin.Api.Util.SIMPLE_POI_TOURISM :
					if( poi.icons && poi.icons.length > 0 && poi.icons[2]!="" && typeof(poi.icons[2])!="undefined" ){
						var img_src   = poi.icons[2];
						var img_alt   = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
						var img_title = poi.icons[3].replace(/\r/g,"").replace(/\n/g,"").replace(/"/g,"&quot;");
						
						content+= '<img src="'+img_src+'" alt="'+img_alt+'" title="'+img_title+'"/>';
					}
					break;
			}
		}
		return content;
	},
	/**
	 * Retourn le type de POI
	 * @param {int} productId
	 * @return {String}
	 */
	getType : function(productId){
		if(ViaMichelin.Api.Constants.System.Poi){
			for(var i=0; i<ViaMichelin.Api.Constants.System.Poi.Hotel.length;i++){
				if(ViaMichelin.Api.Constants.System.Poi.Hotel[i] == productId) return "hotel";
			}
			for(var i=0; i<ViaMichelin.Api.Constants.System.Poi.Restaurant.length;i++){
				if(ViaMichelin.Api.Constants.System.Poi.Restaurant[i] == productId) return "restaurant";
			}
			for(var i=0; i<ViaMichelin.Api.Constants.System.Poi.Tourism.length;i++){
				if(ViaMichelin.Api.Constants.System.Poi.Tourism[i] == productId) return "tourism";
			}
		}
		return "default";
	}
};


//Temporary
ViaMichelin.Api.Util.extend(ViaMichelin.Api.Util.Poi);
